let requestPromise = require('request-promise-native');
const Global = require('./global');

async function navigateWebsite(idHotel, checkin, checkout, adultos, criancas, cupom, childAges) {

    try {

        let options = {
            uri: Global.CRAWLER_ENDPOINT + '/hsystem',
            qs: {
                idHotel: idHotel,
                checkin: checkin,
                checkout: checkout,
                adultos: adultos,
                criancas: criancas,
                cupom : cupom,
                childAges: childAges
            },
            json: true // Automatically parses the JSON string in the response
        };

        let response = await requestPromise.get(options);

        return Promise.resolve(response);

    } catch (err) {
        console.log("caiu aqui no erro");
        console.error(err.error);
        return Promise.reject(err.error);
    }
}


async function getSuggestionDates(idHotel, checkin, checkout, adultos, criancas, cupom, childAges) {

    try {

        let options = {
            uri: Global.CRAWLER_ENDPOINT + '/hsystem/suggestion',
            qs: {
                idHotel: idHotel,
                checkin: checkin,
                checkout: checkout,
                adultos: adultos,
                criancas: criancas,
                cupom : cupom,
                childAges: childAges
            },
            json: true // Automatically parses the JSON string in the response
        };

        let response = await requestPromise.get(options);

        return Promise.resolve(response);

    } catch (err) {
        console.log("caiu aqui no erro");
        console.error(err.error);
        return Promise.reject(err.error);
    }
}



module.exports = {search: navigateWebsite, getSuggestionDates: getSuggestionDates};


