var request = require('request');
var rp = require('request-promise-native');

module.exports = function (apiai) {

    let objrequest = {};

    let URL = "https://api.dialogflow.com/v1/"
    let entitiesCache = null;

    let ob = {
        headers: {
            "Authorization": "Bearer " + apiai
        },
        json: true,
    };

    objrequest.getEntities = function () {

        let obj = Object.assign({url: URL + "entities"}, ob);
        return rp(obj)
    };


    objrequest.getEntity = function (id) {

        let obj = Object.assign({url: URL + "entities/"+id}, ob);
        return rp(obj)
    };

   objrequest.getKeywordsFromEntity =  function(entityModel){

       return new Promise(async (resolve, reject) => {

           let entity = await objrequest.getEntity(entityModel.id);

           let data = [];

           let map = entity.entries.forEach(item => {
               data = data.concat(item.synonyms);
           });

           resolve({key: entity, data: data});
       })

   };
    return objrequest;
};
