

// Require the module and instantiate instance
var TJO = require('asksuite-translate-json-object')();
const Translate = require('@google-cloud/translate');

let defaultAtributes = ['chatTreeId', "dateEnd", "dateInit", "holiday",  "trackId", "dialog", "intent", "tags", "goToDialog", "type", "search", "image", "registerData", "id", "subject", "to", "default", "hsystemKey", "statusRevision", "dialogNewRequest", "compareSuites", "url"];


module.exports = function (config) {

    let translator = {};

    TJO.init({
        url: config.INFOCHAT_DATA_SERVER+"/",
    });

    translator.translate = function (data, language) {

        return new Promise(function(resolve, reject){

            TJO.translate(data, language, defaultAtributes)
                .then(function(data) {
                   resolve(data);
                }).catch(function(err) {
                console.log('error ', err)
                reject(data);
            });
        })
    };



    translator.googleTranslateIfNeed = function(text, target){


        const translate = new Translate({
            key: config.GOOGLE_TRANSLATE_KEY
        });

        return new Promise(function(resolve, reject){


            translate
                .translate(text, {from: target, to: "pt-br"})
                .then(results => {
                    const translation = results[0];

                    console.log(`Text: ${text}`);
                    console.log(`Translation: ${translation}`);

                    resolve(translation);

                })
                .catch(err => {
                    console.error('ERROR:', err);
                    reject(err);
                });

        })

    }

    translator.init = function () {
        return TJO.initMap();
    }




    return translator;
};







// Choose the service to use google/yandex,
// if you provide both yandex will be used as the default


